#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

struct Event{
    int d, h, p;
    bool operator<(const Event &o) const{
        return make_pair(make_pair(d, h), p) < make_pair(make_pair(o.d, o.h), o.p);
    }
};

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector <Event> events(k);
    for (auto &ev : events)
        cin >> ev.d >> ev.h >> ev.p;
    sort(events.begin(), events.end());
    int a1 = 0, a2 = 0;
    set<pair<int, int>> station;
    int waited = 0;
    for (auto ev : events){
        if (ev.p == 1){
            while (waited >= 0 && !station.empty() && *station.begin() <= pair<int, int>{ev.d, ev.h}){
                station.erase(station.begin());
                waited--;
            }
            if (station.size() < n){
                station.insert({ev.d + m, ev.h});
            }
            else
                a1++;
        }
        else if (ev.p == -1){
            if (!station.empty() && *station.begin() <= pair<int, int>{ev.d, ev.h})
                station.erase(station.begin());
            else
                waited++;
        }
    }
    cout << a1 << '\n' << a2 + max(0, waited - int(station.size()));
 }