#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

struct Eratosfen{
    int n;
    vector <bool> arr;
    vector <int> get(){
        vector <int> ans;
        for (int i = 2; i < n; ++i){
            if (arr[i])
                ans.push_back(i);
        }
        return ans;
    }
    Eratosfen(int n): n(n), arr(n, true) {
        for (int i = 4; i < n; i += 2)
            arr[i] = false;
        for (int i = 3; i < n; i += 2){
            if (arr[i]){
                for (int j = 3; i * j < n; j += 2){
                    arr[i * j] = false; 
                }
            }
        }
    }
};

vector <int> primes;

int g(int n){
    int cnt = 0;
    for (int x : primes){
        if (2 * x > n)
            break;
        int d = n - x;
        auto it = lower_bound(primes.begin(), primes.end(), d);
        if (*it == d)
            cnt++;
    }
    return cnt;
}

int main() {
    int a, b;
    cin >> a >> b;
    primes = Eratosfen(b + 1).get();
    if (a % 2 == 1)
        a++;
    int mnt = 1e9, mni;
    for (int i = a; i <= b; i += 2){
        int t = g(i);
        if (t % 5 == 0 && t < mnt){
            mnt = t;
            mni = i;
        }
    }
    if (mnt == int(1e9)){
        cout << "Impossible";
        return 0;
    }
    else{
        cout << mni << ' ' << mnt;
    }
}