#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using db = long double;

ll LNF = 1e18 + 1;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

template <typename T>
istream& operator>>(istream& in, pair<T, T>& a) {
    in >> a.first >> a.second;
    return in;
}


string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, set<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, multiset<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}




void SLN() {
    int n, m, k;
    cin >> n >> m >> k;
    m *= 24;
    vector<ll> arr(10000), dep(10000);
    for (int i = 0; i < k; ++i) {
        ll d, h, t;
        cin >> d >> h >> t;
        (t == 1 ? arr : dep)[d * 24 + h]++;
    }

    multiset<ll> get_ready;
    ll free = n;
    ll ready = 0;
    ll ans1 = 0, ans2 = 0;
    for (int i = 0; i < 10000; ++i) {
        while (get_ready.find(i) != get_ready.end()) {
            get_ready.erase(get_ready.find(i));
            ready++;
        }

        ans2 += dep[i];
        while (ready && ans2) {
            --ready;
            --ans2;
            ++free;
        }

//        if (arr[i] || dep[i])
//            cout << i / 24 << ' ' << i % 24 << ' ' << arr[i] << ' ' << dep[i] << ' ' << free << ' ' << ready << '\n';
        while (arr[i]--) {
            if (free) {
                --free;
                get_ready.insert(i + m);
            } else {
//                cout << i / 24 << ' ' << i % 24 << '\n';
                ans1++;
            }
        }
    }
    cout << ans1 << '\n' << ans2 << '\n';
}




void IOF() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
}


signed main() {
    IOF();

    int T = 1;
    //cin >> T;
    while (T--) {
        SLN();
        cout << '\n';
    }

    exit('U' ^ 'U');
}
