#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using db = long double;

ll LNF = 1e18 + 1;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

template <typename T>
istream& operator>>(istream& in, pair<T, T>& a) {
    in >> a.first >> a.second;
    return in;
}


string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, set<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, multiset<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}




void SLN() {
    bool is_prime[(ll)1e6];
    for (bool & i : is_prime) i = true;
    is_prime[0] = false;
    is_prime[1] = false;

    vector<ll> primes;
    for (ll i = 2; i < (ll)1e6; ++i) {
        if (is_prime[i]) {
            primes.push_back(i);
            for (ll j = i * i; j < (ll)1e6; j += i) {
                is_prime[j] = false;
            }
        }
    }

    ll a, b;
    cin >> a >> b;
    if (b - a > (ll)2e4) b = a + (ll)2e4;

    vector<int> g(1e6 + 1);
    for (int i = 0; i < (int)primes.size(); ++i) {
        for (int j = lower_bound(primes.begin(), primes.end(), a - primes[i]) - primes.begin();
            j <= i && primes[i] + primes[j] <= b;
            ++j) {
            g[primes[i] + primes[j]]++;
        }
    }

    ll ans = 0;
    for (ll i = a + (a % 2); i <= b; i += 2) {
//        cout << i << ' ' << g[i] << '\n';
        if (g[i] % 5 == 0) {
            if (!ans || g[i] < g[ans]) {
                ans = i;
            }
        }
    }
    if (ans) cout << ans << ' ' << g[ans];
    else cout << "Impossible";

//    ll max_dif = 0;
//    ll last = 48;
//    for (ll i = 48; i <= (ll)1e6; i += 2) {
//        if (g[i] % 5 == 0) {
//            max_dif = max(max_dif, i - last);
//            last = i;
//        }
//    }
//    cout << max_dif;

//    SEP = "\n";
//    cout << vector<int>(g.begin(), g.begin() + 30);
//
//    ll cnt = 0;
//    for (int i = 0; i <= 1e6 && cnt < 100; i += 2, ++cnt) {
//        if (g[i] % 5 == 0) {
//            cout << i << ' ' << g[i] << '\n';
//        }
//    }
//
//    ll ans = 0;
//    for (int i = 0; i <= 1e6; i += 2) {
//        if (g[i] % 5 == 0) {
//            ++ans;
//        }
//    }
//    cout << ans;
}




void IOF() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
}


signed main() {
//    IOF();

//    freopen("out.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);

    int T = 1;
    //cin >> T;
    while (T--) {
        SLN();
        cout << '\n';
    }

    exit('U' ^ 'U');
}
