#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using db = long double;

ll LNF = 1e18 + 1;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

template <typename T>
istream& operator>>(istream& in, pair<T, T>& a) {
    in >> a.first >> a.second;
    return in;
}


string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, set<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, multiset<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}




void SLN() {
    int n;
    cin >> n;
    map<ll, bool> stage;
    vector<vector<ll>> rev, dis;
    ll ask = 0, time = 0;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 0) {
            ll j, x;
            cin >> j >> x;
            stage[j] = x;
        }
        if (t == 1) {
            ll u, v;
            cin >> u >> v;
            rev.push_back({u, v});
        }
        if (t == 2) {
            ll u1, u2, v;
            cin >> u1 >> u2 >> v;
            dis.push_back({u1, u2, v});
        }
        if (t == 3) {
            cin >> ask >> time;
        }
    }

    while (time--) {
        map<ll, bool> new_val;
        for (vector<ll> &x : rev) {
            new_val[x[1]] = new_val[x[1]] || !stage[x[0]];
        }
        for (vector<ll> &x : dis) {
            new_val[x[2]] = new_val[x[2]] || (stage[x[0]] && stage[x[1]]);
        }
        for (pair<ll, ll> x : new_val) {
            stage[x.first] = x.second;
        }
        cout << stage[ask] << '\n';
    }
}




void IOF() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
}


signed main() {
    IOF();

    int T = 1;
    //cin >> T;
    while (T--) {
        SLN();
        cout << '\n';
    }

    exit('U' ^ 'U');
}
