#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;

struct event {
    ll b, e, t;

    event(ll _b = 0, ll _e = 0, ll _t = 0) {
		b = _b, t = _t, e = _e;
	}
};

bool operator< (event p1, event p2) {
    return ((p1.b < p2.b) || (p1.b == p2.b && p1.t < p2.t));
}

int main()
{
    ll n, m, k;
    cin >> n >> m >> k;
    vector<event> events;
    for (ll i = 0; i < k; ++i) {
        ll d, h, t;
        cin >> d >> h >> t;
        ll b = d * 24 + h;
        ll e = b + 24 * m;
        events.push_back(event(b, e, t));
    }
    sort(events.begin(), events.end());
    queue<event> q;
    queue<event> wait;
    ll otkaz1 = 0;
    for (ll i = 0; i < k; ++i) {
        if (events[i].t > 0) {
            if (q.size() < n) {
                q.push(events[i]);
            } else {
                while (wait.size() && q.size() && q.front().e <= events[i].b) {
                    wait.pop();
                    q.pop();
                }
                if (q.size() >= n) {
                    ++otkaz1;
                } else {
					q.push(events[i]);
				}
            }
        } else {
            if (q.size() && q.front().e <= events[i].b) {
                q.pop();
            } else {
                wait.push(events[i]);
            }
        }
    }
    while (q.size() && wait.size()) {
        q.pop();
        wait.pop();
    }
    cout << otkaz1 << '\n' << wait.size();
    return 0;
}
