class Hangar:
    def __init__(self):
        self.day = 0
        self.hour = 0
        self.is_ready = False
        self.is_empty = True

    def put_ship_in(self, day, hour):
        self.day = day
        self.hour = hour
        self.is_ready = False
        self.is_empty = False

    def update_hangar(self, current_day, current_hour, repairTime):
        if self.day + repairTime < current_day:
            self.is_ready = True
            return

        if self.day + repairTime == current_day:
            if self.hour < current_hour:
                self.is_ready = True
                return

        self.is_ready = False

    def get_is_ready(self):
        return self.is_ready

    def empty_hangar(self):
        self.day = 0
        self.hour = 0
        self.is_ready = False
        self.is_empty = True

    def get_is_empty(self):
        return self.is_empty


class JornalLine:
    def __init__(self, day, hour, type):
        self.day = day
        self.hour = hour
        self.type = type

def get_empty_hangar(hangars):
    for h in hangars:
        if h.get_is_empty():
            return h
    return None

def get_ready_hangar(hangars):
    for h in hangars:
        if h.get_is_ready():
            return h
    return None

hangarsAmount, repairTime, k = map(int, input().split())

lines = []

for i in range(k):
    day, hour, type = map(int, input().split())

    new_line = JornalLine(day, hour, type)
    lines.append(new_line)

for i in range(0, len(lines)):
    for j in range(i, len((lines))):
        if lines[i].day > lines[j].day:
            lines[i], lines[j] = lines[j], lines[i]

        if lines[i].day == lines[j].day:
            if lines[i].hour > lines[j].hour:
                lines[i], lines[j] = lines[j], lines[i]

            if lines[i].hour == lines[j].hour:
                if lines[i].type > lines[j].type:
                    lines[i], lines[j] = lines[j], lines[i]

hangars = []
for i in range(hangarsAmount):
    new_hangar = Hangar()
    hangars.append(new_hangar)


denied_repairs = 0
flies = []

for theDay in lines:
    for hangar in hangars:
        hangar.update_hangar(theDay.day, theDay.hour, repairTime)

    if theDay.type == 1:
        empty_hangar = get_empty_hangar(hangars)
        if empty_hangar == None:
            denied_repairs += 1
        else:
            empty_hangar.put_ship_in(theDay.day, theDay.hour)

    if theDay.type == -1:
        flies.append(theDay)

    while(get_ready_hangar(hangars) != None):
        hangar = get_ready_hangar(hangars)
        if len(flies) > 0:
            flies.pop(-1)
            hangar.empty_hangar()
        else:
            break

print(denied_repairs)
print(len(flies))