class Point:
    def __init__(self, number, value):
        self.number = number
        self.__value = value
        self.__future_tick_value = value

    def get_value(self):
        return self.__value

    def set_future_tick_value(self, value):
        self.__future_tick_value = value

    def tick(self):
        self.__value = self.__future_tick_value

class LogicElement:
    def tick(self):
        pass

class No(LogicElement):
    def __init__(self, input, output):
        self.input = input
        self.output = output

    def tick(self):
        value = 1 - self.input.get_value()
        self.output.set_future_tick_value(value)

class And(LogicElement):
    def __init__(self, input1, input2, output):
        self.input1 = input1
        self.input2 = input2
        self.output = output

    def tick(self):
        value = self.input1.get_value() and self.input2.get_value()
        self.output.set_future_tick_value(value)

s = input()
f = open(s).readlines()

lines = []
for line in range(1, len(f) - 1):
    lines.append(f[line][:-1])

lines.append(f[-1])
points = []
logitElements = []
ticks = 0
target_point = None

#Points and Task
for line in lines:
    command = list(map(int, line.split()))

    if command[0] == 0:
        new_point = Point(command[1], command[2])
        points.append(new_point)

    if command[0] == 3:
        ticks = command[2]
        target_point = command[1]


def get_point_by_number(number):
    for point in points:
        if point.number == number:
            return point
    return None

#Logic Elements
for line in lines:
    command = list(map(int, line.split()))

    if command[0] == 1:
        new_no = No(get_point_by_number(command[1]), get_point_by_number(command[2]))
        logitElements.append(new_no)

    if command[0] == 2:
        new_and = And(get_point_by_number(command[1]), get_point_by_number(command[2]), get_point_by_number(command[3]))
        logitElements.append(new_and)

for tick in range(ticks):
    for el in logitElements:
        el.tick()

    for point in points:
        point.tick()

    print(get_point_by_number(target_point).get_value())
