#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <list>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <stack>
#include <numeric>
#include <map>
#include <string>
#include <sstream>
#include <iomanip>
#include <ios>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;
typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#pragma warning(disable:4996)

struct Node{
    bool delay = 0;
    bool condition = 0;
    int type = 0; // 0 - точка, 1 - не, 2 - и
    vector<int> to;
    vector<int> from;
    Node(int type, int condition) : type(type), condition(condition) {
        to.resize(0);
        from.resize(0);
        delay = (type > 0);
    }
};

int main(){
    int n, k, t; cin >> n;
    vector<Node> G(5 * n, Node(-1, -1));
    for (int i = 0; i < n; ++i) {
        //cout << i << '\n';
        int type; cin >> type;
        if (type == 0) {
            int num, condition; cin >> num >> condition;
            G[num] = Node(type, condition);
            continue;
        }
        if (type == 1) {
            int from, to; cin >> from >> to;
            G[i + n] = Node(type, 0);

            G[i + n].to.push_back(to);
            G[to].from.push_back(i + n);

            G[i + n].from.push_back(from);
            G[from].to.push_back(i + n);
            continue;
        }
        if (type == 2) {
            int from1, from2, to; cin >> from1 >> from2 >> to;
            G[i + 2 * n] = Node(type, 1);

            G[i + 2 * n].to.push_back(to);
            G[to].from.push_back(i + 2 * n);

            G[i + 2 * n].from.push_back(from1);
            G[from1].to.push_back(i + 2 * n);

            G[i + 2 * n].from.push_back(from2);
            G[from2].to.push_back(i + 2 * n);
            continue;
        }
        else cin >> k >> t;

    }
    deque<pair<int, int>> q;
    vector<int> conds(t + 1, -1);
    for (int i = 0; i < 5 * n; ++i) {
        if (G[i].type == 0) q.push_back({ i, 0 });
        if (i == k) conds[0] = G[i].condition;
    }


    while (!q.empty()) {
        auto u = q.front(); q.pop_front();
        //cout << u.first << ' ' << u.second << ' ' << G[u.first].condition << '\n';
        if (u.second) {
            if (G[u.first].type == 0) {
                int r = 0;
                for (auto e : G[u.first].from) r += G[e].condition;
                G[u.first].condition = (r > 0);
                if (u.first == k) conds[u.second] = G[u.first].condition;
            }
            if (G[u.first].type == 1) {
                G[u.first].condition = not G[G[u.first].from[0]].condition;
            }
            if (G[u.first].type == 2) {
                G[u.first].condition = (G[G[u.first].from[0]].condition and G[G[u.first].from[1]].condition);
            }

        }


        if (u.second > t) break;
        for (auto v : G[u.first].to) {
            if (G[v].delay) q.push_back({ v, u.second + 1 });
            else q.push_front({ v, u.second });
        }

    }
    for (int i = 1; i <= t; ++i) if (conds[i] == -1) conds[i] = conds[i - 1];
    for (int i = 1; i <= t; ++i) cout << conds[i] << '\n';


}

